#include<stdio.h>
#include<math.h>

/* 
-------------------------------------------------------------------------------
"penacho" gaussia 
-------------------------------------------------------------------------------
Dades: malla (nombre de punts d'una aresta de la malla), a (distancia entre
       dos dels punts anteriors), hl (alc,ada de la xemeneia), v (velocitat
       del vent), sour (intensitat de la font).
Resultat: fitxer "aire3.dat". Es pot escollir entre diversos formats depenent
          del programa de representacio grafica que s'estigui fent servir.
          El que hi per defecte va be pel GnuPlot.
Dades de prova: malla=20 a=1000 hl=100 v=1 sour=10 ==>
                2.55275e-17
                0.0594194
                59.838
                631.931
                1718.17
                2736.08
                3400.76
                3722.21
                3799.29
                3725.67
                3568.29
                3370.04
                3156.8
                2943.47
                2738.22
                2545.16
                2366
                2201.09
                2050.03
                ......
Observacions: Si no compila be, provar amb l'opcio -lm. La millor instruccio
              per representar-ho es 'splot "aire3.dat" with lines'.
              En aquest cas no n'hi ha prou amb ser coherents amb el sistema
              d'unitats. Les entrades han de ser en SI i llavors la sortida
              es en micrograms per m^3 (que no es SI).
-------------------------------------------------------------------------------
*/

main()
{
int m,n,malla;
float a,sigmaz,sigmay,hl,v,x,y,z,sour,dmy1,dmy2,dmy3;
FILE *arxiu;

printf("De quants punts faras la malla : ");
scanf("%d",&malla);
printf("Quina es la separacio de la malla en m: ");
scanf("%f",&a);
printf("Alc,ada de la xemeneia en m: ");
scanf("%f",&hl);
printf("Velocitat del vent en m/s: ");
scanf("%f",&v);
printf("Intensitat de la font en Kg/s: ");
scanf("%f",&sour);
printf("Atencio! Sortida en micrograms/m3\n");

arxiu=fopen("aire3.dat","w");

for(n=1;n<malla;n++)
{
for(m=1;m<malla;m++)
	{
	x=m*a;
	y=n*a;
	sigmay=100.0*pow(x*0.001,0.9);
	sigmaz=60.0*pow(x*0.001,0.9);
	dmy1=2.0*exp(-hl*hl/sigmaz/sigmaz/2.0);
	dmy2=exp(-y*y/sigmay/sigmay/2.0);
	dmy3=sour/2.0/3.14/v/sigmay/sigmaz;
	z=dmy1*dmy2*dmy3*1.0E9;
/*	fprintf(arxiu,"%g %g %g\n",x,y,z) ; -- Excel  */
   	fprintf(arxiu,"%g\n",z); /* -- GNUPLOT */
/*   	if(n==1)fprintf(arxiu,"%g %g\n",x,z) ; -- z(x) */
/*   	if(m==60)fprintf(arxiu,"%g %g\n",y,z) ; /* -- z(y) */
	}
   fprintf(arxiu,"\n"); /* -- GNUPLOT */        
}        
fclose(arxiu);
}



